/*
 * Copyright (c) 2005-2010 KOM – Multimedia Communications Lab
 *
 * This file is part of Simonstrator.KOM.
 * 
 * Simonstrator.KOM is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 * 
 * PeerfactSim.KOM is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with PeerfactSim.KOM.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

package de.tudarmstadt.maki.simonstrator.api.component.topology;

import java.util.List;

import de.tudarmstadt.maki.simonstrator.api.component.HostComponent;
import de.tudarmstadt.maki.simonstrator.api.component.overlay.OverlayComponent;

/**
 * Topology Hack needed to place and register the assigned UAVs to the correct
 * control centers.
 * 
 * @author Julian Zobel
 *
 */
public interface UAVNetworkTopologyHack extends HostComponent {

	/**
	 * Register the given overlay component to this topology component
	 * 
	 * @param overlaynode
	 */
	public void register(OverlayComponent overlaynode);

	/**
	 * @return The registered overlay component
	 */
	public OverlayComponent getRegisteredOverlayComponent();

	/**
	 * Get overlay components that are associated with this topology component. In
	 * case of UAVs, this will return the associated control center, in case of a
	 * control center the associated UAV components.
	 * 
	 * @return List of OverlayComponents
	 */
	public List<OverlayComponent> getOverlayNodes();

}
